/*********************************************************************
 * Neophytos Iacovou, University of Minnesota DCS.
 *
 * Copyright 1991, 1992, 1993, 1994 
 * by the Regents of the University of Minnesota
 *
 * see the file "Copyright" in the distribution for conditions of use.
 *********************************************************************/

#include "generateAskForms.h"





NUMBER
main( COUNT caCh_argc, PP_CHAR aaCh_argv )
{
    P_CHAR  aCh_ghost;
    P_CHAR  aCh_binary;
    P_CHAR  aCh_gport;
    P_CHAR  aCh_script; 
    P_CHAR  aCh_location;


    /*
     * Malloc Memory
     */
    aCh_ghost = (P_CHAR) malloc( sizeof(CHAR) * 80 );
    aCh_binary = (P_CHAR) malloc( sizeof(CHAR) * 80 );
    aCh_gport = (P_CHAR) malloc( sizeof(CHAR) * 80 );
    aCh_script = (P_CHAR) malloc( sizeof(CHAR) * 80 );
    aCh_location = (P_CHAR) malloc( sizeof(CHAR) * 80 );

    V_LoadCommandLineArgs( caCh_argc, aaCh_argv, aCh_ghost, aCh_binary,
                           aCh_gport, aCh_script, aCh_location );

    V_ReadZ3950Listing( aCh_ghost, aCh_binary, aCh_gport, aCh_script,
                        aCh_location );


    free( aCh_ghost );
    free( aCh_binary );
    free( aCh_gport );
    free( aCh_script );
    free( aCh_location );

    return( 1 );
}





VOID
V_ReadZ3950Listing( P_CHAR aCh_ghost, P_CHAR aCh_binary, P_CHAR aCh_gport, 
                    P_CHAR aCh_script, P_CHAR aCh_location )
{
    P_FILE  pFil_z3950_list;
    P_FILE  pFil_links;

    P_CHAR  aCh_ask_name;
    P_CHAR  aCh_zhost;
    P_CHAR  aCh_zport; 
    P_CHAR  aCh_zcatalog;
    P_CHAR  aCh_zentry;
    P_CHAR  aCh_tmp;

    COUNT   cCh_tmp_x = 0;



    /*
     * Malloc memory
     */
    aCh_ask_name = (P_CHAR) malloc( sizeof( CHAR ) * 80 );
    aCh_zhost = (P_CHAR) malloc( sizeof( CHAR ) * 80 );
    aCh_zport = (P_CHAR) malloc( sizeof( CHAR ) * 80 );
    aCh_zcatalog = (P_CHAR) malloc( sizeof( CHAR ) * 80 );
    aCh_zentry = (P_CHAR) malloc( sizeof( CHAR ) * 80 );
    aCh_tmp = (P_CHAR) malloc( sizeof( CHAR ) * 5 );

    /*
     * Open the file of Z39.50 catalogs and as long as you 
     * can read from it create ask blocks and forms
     */
    pFil_z3950_list = fopen( "Z39.50_listings", "r" );
    pFil_links = fopen( "_.Links", "w" );

    while ( !(feof( pFil_z3950_list )) )
    {
        fscanf( pFil_z3950_list, "%s\n", aCh_ask_name );
        fscanf( pFil_z3950_list, "%s\n", aCh_zhost );
        fscanf( pFil_z3950_list, "%s\n", aCh_zport ); 
        fscanf( pFil_z3950_list, "%s\n", aCh_zcatalog ); 
        fgets( aCh_zentry, 81, pFil_z3950_list );
        fscanf( pFil_z3950_list, "%s\n", aCh_tmp );

        cCh_tmp_x = strlen( aCh_zentry );
        aCh_zentry [cCh_tmp_x - 1] = '\0';

        V_GenerateLinks( aCh_zentry, aCh_location, aCh_ask_name, pFil_links );
        V_GenerateAskForm( aCh_zentry, aCh_ask_name );
        V_GenerateAskBody( aCh_ask_name, aCh_zhost, aCh_zport, aCh_zcatalog,
                           aCh_ghost, aCh_binary, aCh_gport, aCh_script );

        bzero( aCh_ask_name, 80 );
        bzero( aCh_zhost, 80 );
        bzero( aCh_zport, 80 );
        bzero( aCh_zcatalog, 80 );
        bzero( aCh_zentry, 80 );
        bzero( aCh_tmp, 5 );

    }


    /*
     * Close files
     */
    fclose( pFil_z3950_list );
    fclose( pFil_links );


    /*
     * Free memory
     */
    free( aCh_ask_name );
    free( aCh_zhost );
    free( aCh_zport );
    free( aCh_zcatalog );
    free( aCh_zentry );
    free( aCh_tmp );
}






    /*
     * This function generates a .Links file
     */
VOID
V_GenerateLinks( P_CHAR aCh_zentry, P_CHAR aCh_location, P_CHAR aCh_ask_name,
                    P_FILE pFil_links )
{

    fprintf( pFil_links, "Type=1?\n" );
    fprintf( pFil_links, "Path=0%s/%s\n",aCh_location, aCh_ask_name ); 
    fprintf( pFil_links, "Name=%s\n", aCh_zentry ); 
    fprintf( pFil_links, "Host=+\n" );
    fprintf( pFil_links, "Port=+\n" );
    fprintf( pFil_links, "#\n" );
}






    /*
     * This function generates the ASK form
     */
VOID
V_GenerateAskForm( P_CHAR aCh_zentry, P_CHAR aCh_ask_name )
{

    P_FILE  pFil_askform;

    P_CHAR  aCh_ask_file;

    COUNT   cCh_zentry = 0;
    COUNT   cCh_indent = 0;
    NUMBER  N_i = 0;



    /*
     * Open a new ASK file for writing
     */
    aCh_ask_file = (P_CHAR) malloc( sizeof(CHAR) * 85 );
    sprintf( aCh_ask_file, "%s.ask", aCh_ask_name );
    pFil_askform = fopen( aCh_ask_file, "w" );


    /*
     * Figure out how man spaces are needed to center the name in the window
     */
    cCh_zentry = strlen( aCh_zentry );
    cCh_indent = (80 - cCh_zentry) / 2; 

    
    /*
     * Write out the body
     */
    fprintf( pFil_askform, "Note:" );
    
    for ( N_i = 0;  N_i < cCh_indent; N_i++ )
    {
        fprintf( pFil_askform, " " );
    }

    fprintf( pFil_askform, "%s\n", aCh_zentry );
    fprintf( pFil_askform, "Note: \n" ); 
    fprintf( pFil_askform, "Ask: Title\n" );
    fprintf( pFil_askform, "Ask: Author\n" );
    fprintf( pFil_askform, "Ask: Subject\n" );
    fprintf( pFil_askform, "Ask: MaxRecs\t10\n" );
    fprintf( pFil_askform, "Note: \n" );
    fprintf( pFil_askform, "Note:                   (enter 1 or more of the search fields)\n" );


    /*
     * Close the file
     */
    fclose( pFil_askform );
}






    /*
     * This function generates the ASK body
     */
VOID
V_GenerateAskBody( P_CHAR  aCh_ask_name, P_CHAR  aCh_zhost, P_CHAR  aCh_zport,
                    P_CHAR  aCh_zcatalog,  P_CHAR aCh_ghost, 
                    P_CHAR aCh_binary, P_CHAR aCh_gport, P_CHAR aCh_script )

{

    P_FILE  pFil_askbody;



    /*
     * Open a new body of an ASK file for writing
     */
    pFil_askbody = fopen( aCh_ask_name, "w" );


    /*
     * Write out the body
     */
    fprintf( pFil_askbody, "#!/usr/local/bin/perl\n\n\n" );
    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "# Data that is supplied by the user\n" );
    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "$Title = <>; chop ($Title);\n" );
    fprintf( pFil_askbody, "$Author = <>; chop ($Author);\n" );
    fprintf( pFil_askbody, "$Subject = <>; chop ($Subject);\n" );
    fprintf( pFil_askbody, "$Mrecs = <>; chop ($Mrecs);\n\n\n" );
        
    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "# Security precautions\n" );
    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "$Title =~ s/[^A-Za-z0-9 ]//g;\n" );
    fprintf( pFil_askbody, "$Author =~ s/[^A-Za-z0-9 ]//g;\n" );
    fprintf( pFil_askbody, "$Subject =~ s/[^A-Za-z0-9 ]//g;\n" );
    fprintf( pFil_askbody, "$Mrecs =~ s/[^0-9 ]//g;\n\n\n" );

    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "# Preset Values\n" );
    fprintf( pFil_askbody, "#\n" );
    fprintf( pFil_askbody, "# Host          - Z39.50 host\n" );
    fprintf( pFil_askbody, "# Catalog       - Z39.50 database name\n" );
    fprintf( pFil_askbody, "# Port          - Z30.50 port on the Z39.50 host\n" );
    fprintf( pFil_askbody, "# Operator      - Bool operator applied to the Title, Author, and Subject fields\n" );
    fprintf( pFil_askbody, "# Gopher_host   - Gopher server host\n" );
    fprintf( pFil_askbody, "# Gopher_port   - Gopher port on the gopher server\n" );
    fprintf( pFil_askbody, "# MyPID         - The process ID of this process\n" );
    fprintf( pFil_askbody, "# longdir       - Do we want long dir. listings or not?\n" );
    fprintf( pFil_askbody, "# Binary_Path1  - path to the Z39.50 gateway\n" );
    fprintf( pFil_askbody, "# Binary_Path2  - path to a shell which executed the Z39.50 gateway\n" );
    fprintf( pFil_askbody, "##\n" );

    fprintf( pFil_askbody, "$Host = \"%s\";\n", aCh_zhost ); 
    fprintf( pFil_askbody, "$Catalog = \"%s\";\n", aCh_zcatalog );  
    fprintf( pFil_askbody, "$Port = \"%s\";\n\n", aCh_zport ); 
    fprintf( pFil_askbody, "$Operator = \"AND\";\n" );
    fprintf( pFil_askbody, "$Gopher_host = \"%s\";\n", aCh_ghost );  
    fprintf( pFil_askbody, "$Gopher_port = \"%s\";\n", aCh_gport ); 
    fprintf( pFil_askbody, "$MyPID = $$;\n" );
    fprintf( pFil_askbody, "$longdir = 0;\n" );
    fprintf( pFil_askbody, "$Binary_Path1 = \"%s\";\n", aCh_binary ); 
    fprintf( pFil_askbody, "$Binary_Path2 = \"%s\";\n\n\n", aCh_script );

    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "# Check to see if we are being told to return long or short dir. listings\n" );
    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "$longdir = 1 if ($ENV{\"CONTENT_TYPE\"} eq \"application/gopher+-menu\");\n\n\n" );

    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "# Make our system call\n" );
    fprintf( pFil_askbody, "##\n" );
    fprintf( pFil_askbody, "system \"$Binary_Path1 -I $longdir -h $Host -c $Catalog -p $Port -o $Operator -m \\\"$Mrecs\\\" -T \\\"$Title\\\" -A \\\"$Author\\\" -S \\\"$Subject\\\" -M $MyPID -B $Binary_Path2 -H $Gopher_host -P $Gopher_port\";\n\n\n" );


    /*
     * Close the file
     */
    fclose( pFil_askbody );
}






    /*
     * Load parse the user's input
     */
VOID
V_LoadCommandLineArgs( COUNT caCh_argc, PP_CHAR aaCh_argv, P_CHAR aCh_ghost,
                        P_CHAR aCh_binary, P_CHAR aCh_gport, P_CHAR aCh_script,
                        P_CHAR aCh_location ) 
{
    extern char *optarg;

    FLAG        F_c;
    COUNT       cF_c = 5;
    STRING      Sz_Options = "h:p:b:s:l:";
    


    while (-1 != (F_c = getopt( caCh_argc, aaCh_argv, Sz_Options )))
    {
        switch (F_c)
        {
            case 'h':{
                        strcpy( aCh_ghost, optarg );
                        cF_c--;
                    }
                    break;
                        
            case 'b':{
                        strcpy( aCh_binary, optarg );  
                        cF_c--;
                    }
                    break;

            case 'p':{
                        strcpy( aCh_gport, optarg ); 
                        cF_c--;
                    }
                    break;

            case 's':{
                        strcpy( aCh_script, optarg ); 
                        cF_c--;
                    }
                    break;
            case 'l':{
                        strcpy( aCh_location, optarg );
                        cF_c--;
                    }
                    break;
        }
    }

    if ( 0 != cF_c )
    {
        fprintf( stderr, "Usage: formatter -h gopher_host -p gopher_port -b binary\n                 -s script -l location\n" ); exit (0);
    }
}


