/*********************************************************************
 * Neophytos Iacovou, University of Minnesota DCS.
 *
 * Copyright 1991, 1992, 1993, 1994 
 * by the Regents of the University of Minnesota
 *
 * see the file "Copyright" in the distribution for conditions of use.
 *********************************************************************/

/*
 * Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 *
 * Author:  Ray Larson, ray@sherlock.berkeley.edu
 *      School of Library and Information Studies, UC Berkeley
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *  This product includes software developed by the University of
 *  California, Berkeley.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHOR ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "drs.h"




    /*
     * The output function
     */
xputs (s)
char   *s;
{
    fwrite( s, strlen(s), 1, stdout);
}





display_result_set (char *input, P_CHAR aCh_assoc, char *type, int maxrec,
                    char *esn, char *query,char *stats, INDEX iEnt_to_print,
                    char *host, char *dbname, int port, char *operator, 
                    int mrecs, P_CHAR aCh_title, P_CHAR aCh_author,
                    P_CHAR aCh_subject, P_CHAR aCh_marc_file, 
                    P_CHAR aCh_gopher_host, P_CHAR aCh_binary_path, 
                    NUMBER N_gopher_port, BOOL B_info )
{
    int     i;
    char    fname[50],
            buffer[1024],
            buf[7];
    int     infile;
    NUMBER  N_assocfile;
    long    pos = 0L;
    int     len,
            search_time,
            hits;
    char    *p,
            myfile[100];
    int     start_set,
            end_set;
    FILE    *fp, *fin, *fassoc;
    int     format;
    long    numhits = 0, numrecs = 0;
    extern  int  xputs ();
    char    s[80];
    P_CHAR  aCh_view_heading;

    STRING  Sz_format1 = "0%s\texec:-h %s -c %s -p %i -o %s -m %i -T \"%s\" -A \"%s\" -S \"%s\" -M %s -B %s -H %s -P %i -f %li:%s\t%s\t%i\r\n";



    if (!strcasecmp (type, "1.2.840.10003.5.10"))
        format = MARC;
    else if (!strcasecmp (type, "1.2.840.10003.5.101"))
        format = SUTRS;
    else
        format = HTML;

    /*
     * Opens the MARC file and its Associator File
     */
    fin = fopen ( input, "r" );
    fassoc = fopen( aCh_assoc, "r" );

    if (fin != NULL)
        infile=fileno(fin);

    if ( fassoc != NULL )
    {
        N_assocfile = fileno( fassoc );
    }

    fp=fopen(stats,"r");
    fgets(s, sizeof(s)-1, fp);
    if (s[0] == 'S') {
        fgets(s, sizeof(s)-1, fp);
        sscanf(s,"%ld",&numhits);
        fgets(s, sizeof(s)-1, fp);
        sscanf(s,"%ld",&numrecs);
        fclose(fp);
    } 
    else {
        while ( fgets(s, sizeof(s)-1, fp) != NULL )
            printf(s);

        fclose(fp);
        return;
    }

    if (fin == NULL)
        return;

/*  printf("Results of your query (%ld hits, %ld records returned)%s\n\n",numhits,numrecs,query); */


    if ( -2 == iEnt_to_print )
    {
        maxrec = numhits;
    }

    /* 
     * If we are in the mode of creating a list of menu options for the
     * user then we should create a psuedo-option of allowing the 
     * viewing of all the found records in long format
     */
    if ( -1 == iEnt_to_print ) 
    {
        if ( B_info )
        {
            printf( "+INFO: " );
        }

        aCh_view_heading = (P_CHAR) malloc( sizeof( CHAR ) * 80 );
        sprintf( aCh_view_heading, "View All Of The Retreived Records: %ld total hits, %ld returned", numhits, numrecs );

        printf( Sz_format1, aCh_view_heading, host, dbname, port, operator, 
                mrecs, aCh_title, aCh_author, aCh_subject, aCh_marc_file, 
                aCh_binary_path, aCh_gopher_host, N_gopher_port, -2, 
                aCh_binary_path, aCh_gopher_host, N_gopher_port );
    }


    if ( (-1 == iEnt_to_print) || (-2 == iEnt_to_print) )
    {
        for (i = 0; i < numrecs; i++)
        {
            V_PrintEntry( N_assocfile, esn, infile, buffer, fin, format, i,
                            host, dbname, port, operator, mrecs, aCh_title, 
                            aCh_author, aCh_subject, aCh_marc_file, 
                            aCh_gopher_host, aCh_binary_path, N_gopher_port,
                            B_info );

            if ( -2 == iEnt_to_print )
            {
                printf( "\r\n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\r\n\r\n" );
            }
        }
    }
    else
    {
        V_PrintEntry( N_assocfile, esn, infile, buffer, fin, format, 
                        iEnt_to_print, host, dbname, port, operator, mrecs, 
                        aCh_title, aCh_author, aCh_subject, aCh_marc_file, 
                        aCh_gopher_host, aCh_binary_path, N_gopher_port,
                        B_info );


    }

    fclose( fassoc );
}





    /*
     * given an index into a realm of possible entries this will
     * select the proper entry and display it.
     *
     * BTW: I think this only works for MARC fields, I should test
     *      the other formats someday day 
     */
VOID
V_PrintEntry( NUMBER N_assocfile, P_CHAR esn, NUMBER infile,  P_CHAR buffer, 
                FILE *fin, FLAG F_format, INDEX iEnt_i, char *host, 
                char *dbname, int port, char *operator, int mrecs, 
                P_CHAR aCh_title, P_CHAR aCh_author, P_CHAR aCh_subject, 
                P_CHAR aCh_marc_file, P_CHAR aCh_gopher_host, 
                P_CHAR aCh_binary_path, NUMBER N_gopher_port, BOOL B_info )
{

    switch (F_format) 
    {
        case MARC:
        {
            int vtype = 0;
    
            if (!strcasecmp(esn,"B"))
                vtype=1;
    
            if (DispMARC ( infile, N_assocfile, iEnt_i, vtype, -1, 
                            70, xputs, host, dbname, port, operator, mrecs,
                            aCh_title, aCh_author, aCh_subject, aCh_marc_file,
                            aCh_gopher_host, aCh_binary_path, N_gopher_port,
                            B_info ) 
                        == NULL)
                break;
        }
        break;

        case SUTRS: 
        {
            for (;;) 
            {
                if (fgets (buffer, 100, fin) == NULL)
                    return;
            
                if (!strstr (buffer, "-----"))
                    printf ("%s\n", buffer);
                else
                    break;
            }
        }
        break;

        case NONE: 
        case HTML: 
        {
            for (;;) 
            {
                if (fgets (buffer, 100, fin) == NULL)
                    return;
                
                if (!strstr (buffer, "-----"))
                    printf ("%s", buffer);
                else
                    break;
            }
        }
        break;
    }

}
