/*********************************************************************
 * Neophytos Iacovou, University of Minnesota DCS.
 *
 * Copyright 1991, 1992, 1993, 1994 
 * by the Regents of the University of Minnesota
 *
 * see the file "Copyright" in the distribution for conditions of use.
 *********************************************************************/

/*************************************************************************

Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 

*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "go4zgate.h"
#include "conf.h"
#include "standard.h"





main ( COUNT caCh_argc, PP_CHAR aaCh_argv )
{
    int     x; 
    int     cl;
    int     i;
    char    *query;
    char    tempCmd[256];
    char    output_file[100], statsfile[100], inifile[100], fwaisfile[100];
    P_CHAR  aCh_assoc_file;
    char    cmdbuf[1024];
    FILE    *fp;






    /* Reserve some memory */
    aCh_title = (P_CHAR) malloc( sizeof(CHAR) * d_MAX_TERM_LENGTH );
    aCh_author = (P_CHAR) malloc( sizeof(CHAR) * d_MAX_TERM_LENGTH );
    aCh_subject = (P_CHAR) malloc( sizeof(CHAR) * d_MAX_TERM_LENGTH );
    aCh_marc_file = (P_CHAR) malloc( sizeof(CHAR) * d_MAX_TERM_LENGTH );
    aCh_gopher_host = (P_CHAR) malloc( sizeof(CHAR) * d_MAX_TERM_LENGTH );
    aCh_binary_path = (P_CHAR) malloc( sizeof(CHAR) * d_MAX_TERM_LENGTH );



    /*
     * Scan the command line arguements and fill in some of the required
     * fields. Note, some of the required fields DO NOT come from the
     * command line, we make the user-interface easier to work by setting
     * up default values for those fields.
     */
    V_LoadCommandLineArgs( caCh_argc, aaCh_argv, host, dbname, &port, operator,
                            &mrecs, aCh_title, aCh_author, aCh_subject, 
                            aCh_marc_file, aCh_binary_path, aCh_gopher_host, 
                            &N_gopher_port, &B_info, &iEnt_to_print );
    V_FillInDefaultFields( iEnt_to_print, esn, rtype, attrset );



    /*
     * We can't continue unless some of the fields are filled in
     */
    V_InitFieldErrorChecks( B_info, mrecs, aCh_title, aCh_author, aCh_subject,
                            aCh_gopher_host, N_gopher_port, host, dbname, 
                            port, operator );


    /*
     * Create the filenames for this session
     */
    sprintf ( output_file, "/tmp/%s.out", aCh_marc_file );
    sprintf ( statsfile, "/tmp/%s.stat", aCh_marc_file );
    sprintf ( inifile, "/tmp/%s.ini", aCh_marc_file );
    sprintf ( fwaisfile, "/tmp/%s.fwais", aCh_marc_file );
    aCh_assoc_file = (P_CHAR) malloc( sizeof( CHAR )  * 107 );
    sprintf( aCh_assoc_file, "/tmp/%s.assoc", aCh_marc_file );



    /*
     * If we did not receive a Marc file from the command line args,
     * or, if we did receive one and we can not access it 
     * then we must generate one via the other args we were given
     */
    if ( FALSE == B_FilesStat( output_file, statsfile, inifile, fwaisfile,
                                aCh_assoc_file ) )
    {

    /*
     * Create the terms using the values of Title/Author/Subject
     * supplied by the user.
     */
        V_InitTermEntries( maxterms );

        build_term_array ();

        for (x = 1; x <= maxterms && strlen (terms[x].term) > 0; x++)
        {
            dterms[x] = build_term (x);
        }

        maxterms = x - 1;
        query = construct_query ();

    /* record syntax definitions */
        {
            FILE *nfp=fopen("/tmp/temp.txt","w");
            fprintf(nfp,"%s",rtype);
            fclose(nfp);
        }

    /* attribute set definitions */
        V_SetAttrSetDefs( rtype, delim, attrset );

    /* write the data out to a file */
        V_WriteInifile( inifile, host, port, dbname, query, esn, rtype, mrecs, 
                        output_file, statsfile, attrset, delim, fwaisfile );

        sprintf(cmdbuf, "%s -i%s,zgate", d_LOCATION_OF_FWAIS_BINARY, inifile);
        system(cmdbuf);


    /*
     * Check to see if the user reuested too many hits to be returned.
     * If he did then an error will shorty occur and we must stop
     * that from happening.
     */


    /*
     * Create an Associator File
     */
        OpenAssocFile( output_file, aCh_assoc_file );

    }
    else
    {

    /* attribute set definitions */
        V_SetAttrSetDefs( rtype, delim, attrset );
    }



    /*
     * Display the resulting hits
     */

    /*printf( "+-1\r\n" );*/
    display_result_set ( output_file, aCh_assoc_file, rtype, mrecs, esn, 
                         query, statsfile, iEnt_to_print, host, dbname,
                         port, operator, mrecs, aCh_title, aCh_author,
                         aCh_subject, aCh_marc_file, aCh_gopher_host,
                         aCh_binary_path, N_gopher_port, B_info,
                         statsfile, inifile, fwaisfile, output_file, 
                         aCh_assoc_file );
    /*printf( ".\r\n" );*/

}





int
ztoi (char *p, int type) 
{
    int i;

    if (!strlen (p))
        return (-1);
    
    switch(type){
        case USE:
        for(i=0; i<use_tab_count; i++){
            if(!strcasecmp(p,use_tab[i].name)){
                return(use_tab[i].value);
            }
        }
        return(1); /* default=title */
        case RELATION:
        for(i=0; i<rel_tab_count; i++){
                        if(!strcasecmp(p,rel_tab[i].name))
                                return(rel_tab[i].value);
                }
                return(3); /* default=equal */  
        case STRUCTURE:
        for(i=0; i<struct_tab_count; i++){
                    if(!strcasecmp(p,struct_tab[i].name))
                            return(struct_tab[i].value);
        }

                return(2); /* default=word */
    }
}





build_term_array () 
{
    int     i, j;
    char    use[100],
            structure[100],
            position[100],
            term[100],
            truncation[100],
            relation[100];

    for (i = 0; i < 4; i++) 
    {   /* for each possibility */
        sprintf (term, "term_term_%d", i);
        sprintf (use, "term_use_%d", i);
        sprintf (structure, "term_struct_%d", i);
        sprintf (position, "term_pos_%d", i);
        sprintf (truncation, "term_trunc_%d", i);
        sprintf (relation, "term_rel_%d", i);

        for (j = 0; j < maxterms; j++) 
        {/* for each one sent by client */

            if (!strcasecmp (entries[j].name, term))
                strcpy (terms[i].term, entries[j].val);

            if (!strcasecmp (entries[j].name, use))
                terms[i].use = ztoi (entries[j].val,USE);

            if (!strcasecmp (entries[j].name, position))
                terms[i].position = ztoi (entries[j].val,POSITION);

            if (!strcasecmp (entries[j].name, structure))
                terms[i].structure = ztoi (entries[j].val,STRUCTURE);

            if (!strcasecmp (entries[j].name, relation))
                terms[i].relation = ztoi (entries[j].val,RELATION);

            if (!strcasecmp (entries[j].name, truncation))
                terms[i].truncation = ztoi (entries[j].val,TRUNCATION);
        }

    }
}






char   *build_term (i) 
{
    char    buf[100], tmp[100];
    char   *p;


    if (!strlen (terms[i].term))
        return (NULL);

    if (check_attrs (i) == 0)
        return (strdup (terms[i].term));

    sprintf (buf, "%s[", terms[i].term);

    if (terms[i].use > 0) 
    {
        sprintf (tmp, "%d,%d,", 1, terms[i].use);
        strcat (buf, tmp);
    }

    if (terms[i].relation > 0) 
    {
        sprintf (tmp, "%d,%d,", 2, terms[i].relation);
        strcat (buf, tmp);
    }

    if (terms[i].structure > 0) 
    {
        sprintf (tmp, "%d,%d,", 4, terms[i].structure);
        strcat (buf, tmp);
    }
    
    if (terms[i].position > 0) 
    {
        sprintf (tmp, "%d,%d,", 3, terms[i].position);
        strcat (buf, tmp);
    }
    
    if (terms[i].truncation > 0) 
    {
        sprintf (tmp, "%d,%d,", 5, terms[i].truncation);
        strcat (buf, tmp);
    }

    p = (char*)strrchr (buf, ',');

    if (p)
        *p = ']';

    return (strdup (buf));
}





check_attrs (i) {
    int     count = 0;

    if (terms[i].use > 0)
        ++count;

    if (terms[i].position > 0)
        ++count;
    
    if (terms[i].relation > 0)
        ++count;

    if (terms[i].truncation > 0)
        ++count;
    
    if (terms[i].position > 0)
        ++count;
    
    if (terms[i].structure > 0)
        ++count;

    return (count);
}





static int  i = 0;
char   *construct_query () {
    char    buf[500];
    char   *p;

    if (maxterms == 1)
    {
        return (strdup (dterms[1]));
    }

    if (i == maxterms - 2) 
    {
        sprintf (buf, "%s(%s,%s)", operator, dterms[i + 1], dterms[i + 2]);
    }
    else 
    {
        ++i;
        p = construct_query ();
        --i;
        sprintf (buf, "%s(%s,%s)", operator, dterms[i + 1], p);
        free (p);
    }

    return (strdup (buf));
}





    /*
     * Arguement list:
     *
     *  -h -c -p -o -m -T -A -S -M -B -H -P [-I] [-f]
     *
     * -h => host
     * -c => catalog
     * -p => port
     * -o => operator
     * -m => max number of recs to be returned
     * -T => title
     * -A => author
     * -S => subject
     * -M => a unique number (a PID will work -- in most cases)
     * -B => path_to_binary 
     * -H => gopher_host 
     * -P => gopher_port
     * -I => info_on (yes for unix, no for macs)
     * -f => number of record to be fetched
     */

VOID
V_LoadCommandLineArgs( COUNT caCh_argc, PP_CHAR aaCh_argv, P_CHAR aCh_host,
                        P_CHAR aCh_dbname, P_NUMBER pN_port, 
                        P_CHAR aCh_operator, P_NUMBER pN_mrecs, 
                        P_CHAR aCh_title, P_CHAR aCh_author, 
                        P_CHAR aCh_subject, P_CHAR aCh_marc_file,
                        P_CHAR aCh_binary_path, P_CHAR aCh_gopher_host,
                        P_NUMBER pN_gopher_port, P_BOOL pB_info,
                        P_INDEX piEnt_to_print )
{
    extern char *optarg;

    FLAG        F_c;
    COUNT       cF_c = d_C_NUM_REQUIRED_ARGS;
    STRING      Sz_Options = "h:c:p:o:m:T:A:S:M:B:H:P:I:f:";
    

    /* Altough we allow the user to think these are optional they are not */
    iEnt_to_print = -1;

    while (-1 != (F_c = getopt( caCh_argc, aaCh_argv, Sz_Options )))
    {
        switch (F_c)
        {
            case 'h':{
                        strcpy( aCh_host, optarg );
                        cF_c--;
                    }
                    break;
                        
            case 'c':{
                        strcpy( aCh_dbname,  optarg );  
                        cF_c--;
                    }
                    break;

            case 'p':{
                        *pN_port = atoi( optarg ); 
                        cF_c--;
                    }
                    break;

            case 'o':{
                        strcpy( aCh_operator, optarg ); 
                        cF_c--;
                    }
                    break;

            case 'm':{
                        if ( 0 == strcmp( optarg, "" ) )
                        {
                            *pN_mrecs = -1;
                        }
                        else
                        {
                            *pN_mrecs = atoi( optarg ); 
                        }
                        cF_c--;
                    }
                    break;

            case 'T':{
                        strcpy( aCh_title, optarg ); 
                        cF_c--;
                    }
                    break;

            case 'A':{
                        strcpy( aCh_author, optarg ); 
                        cF_c--;
                    }
                    break;

            case 'S':{
                        strcpy( aCh_subject, optarg );  
                        cF_c--;
                    }
                    break;

            case 'M':{
                        strcpy( aCh_marc_file, optarg );
                        cF_c--;
                    }
                    break;

            case 'B':{
                        strcpy( aCh_binary_path, optarg );
                        cF_c--;
                    }
                    break;

            case 'H':{
                        strcpy( aCh_gopher_host, optarg );
                        cF_c--;
                    }
                    break;

            case 'P':{
                        *pN_gopher_port = atoi( optarg );
                        cF_c--;
                    }
                    break;

            case 'I':{
                        *pB_info = atoi( optarg );
                    }
                    break;

            case 'f':{
                        *piEnt_to_print = atoi(optarg ); 
                    }
                    break;
        }
    }


    if ( 0 != cF_c )
    {
/*      fprintf( stderr, "Usage: go4zgate -h host -c database_catalog -p port -o operator\n                -m max_#_records_to_return -T title -A author -S subject\n                -M marc_file -B path_to_binary -H gopher_host -P gopher_port\n                [-I info_on] [-f record_to_return]\n" ); exit (0) */
    }

}





    /*
     * Some of the fields required to connect to the host and database do
     * not come from the user, rather, they have default values. We set
     * those values up here
     */
VOID
V_FillInDefaultFields( INDEX iEnt_to_print, P_CHAR aCh_esn, 
                        P_CHAR aCh_rtype, P_CHAR aCh_attrset )
{
    /*
     * Before we set this field we must figure out how the user
     * wants to see the hits, in LONG mode "F", or in SHORT mode "B".
     *
     * The rule for determining this is rather simple. If the user wants
     * to view a specific hit or all of the hits display them in LONG
     * mode, otherwise stick to SHORT mode. 
     */

    if ( -1 == iEnt_to_print )
    {
        strcpy( aCh_esn, "B" );
    }
    else
    {
        strcpy( aCh_esn, "F" );
    }

    strcpy( aCh_rtype, "USMARC" );
    strcpy( aCh_attrset, "BIB1" );
}





    /*
     * Set up the term (ie, Title, Author, Subject) fields.
     * The terms - I am not yet 100% sure I understand how these
     * terms are parsed to create the proper query - the problem is
     * that they don't seem to be parsed at all - perhaps the server
     * does that? I dunno
     */

VOID
V_InitTermEntries( COUNT cEnt_m )
{

    INDEX   iEnt_x;


    /* malloc the mem needed to store our title/author/subject entries */
    for (iEnt_x = 0; iEnt_x <= cEnt_m ; iEnt_x++)
    {
        entries[iEnt_x].name = (P_CHAR) malloc( 
                    sizeof(CHAR) * d_MAX_TERM_LENGTH );

        entries[iEnt_x].val = (P_CHAR) malloc( 
                    sizeof(CHAR) * d_MAX_TERM_LENGTH );
    }


    /* here is where we fill in the blanks */
    strcpy ( entries[0].name, "term_term_1" );
    strcpy ( entries[0].val,  aCh_title );
    strcpy ( entries[1].name, "term_use_1" );
    strcpy ( entries[1].val, "TITLE" );
    strcpy ( entries[2].name, "term_struct_1" );
    strcpy ( entries[2].val, "word list" );
    strcpy ( entries[3].name, "term_pos_1" );
    strcpy ( entries[3].val, "" );
    strcpy ( entries[4].name, "term_trunc_1" );
    strcpy ( entries[4].val, "" );
    strcpy ( entries[5].name, "term_rel_1" );
    strcpy ( entries[5].val, "3" );

    strcpy ( entries[6].name, "term_term_2" );
    strcpy ( entries[6].val, aCh_author );
    strcpy ( entries[7].name, "term_use_2" );
    strcpy ( entries[7].val, "AUTHOR" );
    strcpy ( entries[8].name, "term_struct_2" );
    strcpy ( entries[8].val, "word list" );
    strcpy ( entries[9].name, "term_pos_2" );
    strcpy ( entries[9].val, "" );
    strcpy ( entries[10].name, "term_trunc_2" );
    strcpy ( entries[10].val, "" );
    strcpy ( entries[11].name, "term_rel_2" );
    strcpy ( entries[11].val, "3" );

    strcpy ( entries[12].name, "term_term_3" );
    strcpy ( entries[12].val, aCh_subject );
    strcpy ( entries[13].name, "term_use_3" );
    strcpy ( entries[13].val, "SUBJECT" );
    strcpy ( entries[14].name, "term_struct_3" );
    strcpy ( entries[14].val, "word list" );
    strcpy ( entries[15].name, "term_pos_3" );
    strcpy ( entries[15].val, "" );
    strcpy ( entries[16].name, "term_trunc_3" );
    strcpy ( entries[16].val, "" );
    strcpy ( entries[17].name, "term_rel_3" );
    strcpy ( entries[17].val, "3" );

    
    /*
     * We must make sure that no NULL val occurs in
     * an entry before a "real" value" does
     */

    if ( 0 != strcmp( aCh_subject, "" ) )
    {
        strcpy ( entries[7].val, "SUBJECT" );
        strcpy ( entries[6].val, aCh_subject );

        strcpy ( entries[13].val, "AUTHOR" );
        strcpy ( entries[12].val, aCh_author );

        if ( 0 == strcmp( aCh_title, "" ) )
        {
            strcpy ( entries[1].val, "SUBJECT" );
            strcpy ( entries[0].val, aCh_subject );

            strcpy ( entries[7].val, "TITLE" );
            strcpy ( entries[6].val, aCh_title );
        }
    }
    else
    {
        if ( 0 == strcmp( aCh_title, "" ) )
        {
            strcpy ( entries[1].val, "AUTHOR" );
            strcpy ( entries[0].val, aCh_author );

            strcpy ( entries[7].val, "TITLE" );
            strcpy ( entries[6].val, aCh_title );
        }


    /*
     * Print( you must provide me with some fields )
     */

    }

}




    /*
     * Given a list of filenames make sure that they are all still there.
     */

BOOL
B_FilesStat( P_CHAR aCh_output_file, P_CHAR aCh_statsfile, P_CHAR aCh_inifile, 
            P_CHAR aCh_fwaisfile, P_CHAR aCh_assoc_file )
{            

    STAT_STRUCT Sta_stat_buffer1;
    STAT_STRUCT Sta_stat_buffer2;
    STAT_STRUCT Sta_stat_buffer3;
    STAT_STRUCT Sta_stat_buffer4;
    STAT_STRUCT Sta_stat_buffer5;


    if (  (-1 == stat( aCh_output_file, &Sta_stat_buffer1 )) ||
          (-1 == stat( aCh_statsfile, &Sta_stat_buffer2 )) ||
          (-1 == stat( aCh_inifile, &Sta_stat_buffer3 )) ||
          (-1 == stat( aCh_fwaisfile, &Sta_stat_buffer4 )) ||
          (-1 == stat( aCh_assoc_file, &Sta_stat_buffer5 )) ) 
    {
        return( FALSE );
    }
    else
    {
        return( TRUE );
    }
    
}





    /*
     * attribute set definitions
     */ 
VOID
V_SetAttrSetDefs( P_CHAR aCh_rtype, P_CHAR aCh_delim, P_CHAR aCh_attrset )
{
    strcpy( aCh_delim, "");
    if (strcmp( aCh_rtype, "SUTRS") == 0) {
        strcpy( aCh_rtype, "1.2.840.10003.5.101");
        strcpy( aCh_delim, "\n-----\n");
    }
    if (strcmp( aCh_rtype, "USMARC") == 0) {
        strcpy( aCh_rtype, "1.2.840.10003.5.10");
        strcpy( aCh_delim, "");
    }


    if (strcmp( aCh_attrset, "STAS") == 0)
        strcpy( aCh_attrset, "1.2.840.10003.3.1000.6.1");
    if (strcmp( aCh_attrset, "BIB1") == 0)
        strcpy( aCh_attrset, "1.2.840.10003.3.1");

}





    /*
     * Write out "inifile"
     */
VOID
V_WriteInifile( P_CHAR aCh_inifile, P_CHAR aCh_host, NUMBER N_port, 
                P_CHAR aCh_dbname, P_CHAR aCh_query, P_CHAR aCh_esn, 
                P_CHAR aCh_rtype, NUMBER N_mrecs, P_CHAR aCh_output_file, 
                P_CHAR aCh_statsfile, P_CHAR aCh_attrset, P_CHAR aCh_delim,
                P_CHAR aCh_fwaisfile ) 
{
    P_FILE  pFil_to_open;


    pFil_to_open = fopen( aCh_inifile, "w" );
    fprintf( pFil_to_open, "[*zgate]\n" );
    fprintf( pFil_to_open, "Host=%s\n", aCh_host );
    fprintf( pFil_to_open, "Port=%d\n", N_port );
    fprintf( pFil_to_open, "sDBNames=%s\n", aCh_dbname );
    fprintf( pFil_to_open, "sQuery=%s\n", aCh_query );
    fprintf( pFil_to_open, "pElementSetNames=%s\n", aCh_esn );
    fprintf( pFil_to_open, "pPreferredRecSyntax=%s\n", aCh_rtype );
    fprintf( pFil_to_open, "pNumRecsReq=%d\n", N_mrecs );
    fprintf( pFil_to_open, "OutputFile=%s\n", aCh_output_file );
    fprintf( pFil_to_open, "StatsFile=%s\n", aCh_statsfile );
    fprintf( pFil_to_open, "sAttributeSet=%s\n", aCh_attrset );
    fprintf( pFil_to_open, "dDelimiter=%s\n", aCh_delim );
    fprintf( pFil_to_open, "pResultSetStartPoint=1\n" );
    fprintf( pFil_to_open, "NoWait=TRUE\n" );
    fprintf( pFil_to_open, "LogFile=%s\n", aCh_fwaisfile );
    fclose( pFil_to_open);
}





    /*
     * We can't continue unless some of the fields are filled in
     */
VOID
V_InitFieldErrorChecks( BOOL B_info, NUMBER N_mrecs, P_CHAR aCh_title,
                        P_CHAR aCh_author, P_CHAR aCh_subject,
                        P_CHAR aCh_gopher_host, NUMBER N_gopher_port,
                        P_CHAR aCh_host, P_CHAR aCh_dbname, NUMBER N_port,
                        P_CHAR aCh_operator )
{


    /* 
     * Check to see that the max number of records
     *  to be returned is valid 
     */
    if ( 0 >= N_mrecs )
    {
        V_PrintQcnbcError( B_info, aCh_gopher_host, N_gopher_port );
    }



    /* 
     * Check to see that at least one of the search 
     * fields contains valid  data
     */
    if ( (0 == strcmp( aCh_title, "" )) && (0 == strcmp( aCh_author, "" )) &&
                (0 == strcmp( aCh_subject, "" )) )
    {
        V_PrintQcnbcError( B_info, aCh_gopher_host, N_gopher_port );
    }


    
    /*
     * Check to see that the host name was provide and not NULL
     */
    if ( 0 == strcmp( aCh_host, "" ) )
    {
        V_PrintQcnbcError( B_info, aCh_gopher_host, N_gopher_port );
    }



    /*
     * Check to see that the catalog name was provide and not NULL
     */
    if ( 0 == strcmp( aCh_dbname, "" ) )
    {
        V_PrintQcnbcError( B_info, aCh_gopher_host, N_gopher_port );
    }



    /*
     * Check to see that the port number is valid
     */
    if ( 0 >= N_port )
    {
        V_PrintQcnbcError( B_info, aCh_gopher_host, N_gopher_port );
    }


    
    /*
     * Check to see that the operator is not NULL
     */
    if ( 0 == strcmp( aCh_operator, "" ) )
    {
        V_PrintQcnbcError( B_info, aCh_gopher_host, N_gopher_port );
    }

}





    /*
     * Print "Query Could Not Be Conducted - Invalid Input" error
     */ 
VOID
V_PrintQcnbcError( BOOL B_info, P_CHAR aCh_gopher_host, NUMBER N_gopher_port )
{

     STRING  Sz_qcnbc = "iQuery Could Not Be Conducted - Invalid Input\t\t%s\t%i\r\n";

    if ( B_info )
    {
        printf( "+INFO: " );
    }

    printf( Sz_qcnbc, aCh_gopher_host, N_gopher_port );
    exit(0);
}



