/*********************************************************************
 * Neophytos Iacovou, University of Minnesota DCS.
 *
 * Copyright 1991, 1992, 1993, 1994 
 * by the Regents of the University of Minnesota
 *
 * see the file "Copyright" in the distribution for conditions of use.
 *********************************************************************/


/*************************************************************************

Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 

*************************************************************************/

/*-----------------------------------------------------------------------------
 * Header File: go4zgate.h
 *
 *----------------------------------------------------------------------------*/
#ifndef _GO4ZGATE_H_
#define _GO4ZGATE_H_


#include <stdio.h>
#include <stdlib.h>
#include "standard.h"


    /* 
     * Defines and Macros
     */

#define USE 1
#define RELATION 2
#define POSITION 3
#define STRUCTURE 4
#define TRUNCATION 5
#define MAX_ENTRIES 10000
#define d_C_NUM_REQUIRED_ARGS 12
#define d_MAX_TERM_LENGTH 150





    /*
     * Functions
     */

char *build_term (); 

char *strdup (); 

char *construct_query ();

char *makeword (char *line, char stop);

char *fmakeword (FILE * f, char stop, int *len);

char x2c (char *what);

void unescape_url (char *url);

void plustospace (char *str);

VOID V_LoadCommandLineArgs( COUNT caCh_argc, PP_CHAR aaCh_argv, P_CHAR aCh_host,
                            P_CHAR aCh_dbname, P_NUMBER pN_port, 
                            P_CHAR aCh_operator, P_NUMBER pN_mrecs, 
                            P_CHAR aCh_title, P_CHAR aCh_author, 
                            P_CHAR aCh_subject, P_CHAR aCh_marc_file,
                            P_CHAR aCh_binary_path, P_CHAR aCh_gopher_host,
                            P_NUMBER pN_gopher_port, P_BOOL pB_info,
                            P_INDEX piEnt_to_print );

VOID V_FillInDefaultFields( INDEX iEnt_to_print, P_CHAR aCh_esn,
                            P_CHAR aCh_rtype, P_CHAR aCh_attrset );

VOID V_InitTermEntries( COUNT cEnt_m );

BOOL B_FilesStat( P_CHAR aCh_output_file, P_CHAR aCh_statsfile, 
            P_CHAR aCh_inifile, P_CHAR aCh_fwaisfile, P_CHAR aCh_assoc_file );

VOID V_SetAttrSetDefs( P_CHAR aCh_rtype, P_CHAR aCh_delim, P_CHAR aCh_attrset );

VOID V_ExecQuery( P_CHAR aCh_host, P_CHAR aCh_dbname, NUMBER N_port, 
                  P_CHAR aCh_operator, NUMBER N_mrecs, P_CHAR aCh_title,
                  P_CHAR aCh_author, P_CHAR aCh_subject, P_CHAR aCh_marc_file,
                  P_CHAR aCh_gopher_host, P_CHAR aCh_binary_path,
                  NUMBER N_gopher_port, BOOL B_info, L_NUMBER lN_numhits,
                  P_CHAR aCh_statsfile, P_CHAR aCh_inifile, 
                  P_CHAR aCh_fwaisfile, P_CHAR aCh_output_file, 
                  P_CHAR aCh_assoc_file );

VOID V_WriteInifile( P_CHAR aCh_inifile, P_CHAR aCh_host, NUMBER N_port, 
                     P_CHAR aCh_dbname, P_CHAR aCh_query, P_CHAR aCh_esn, 
                     P_CHAR aCh_rtype, NUMBER N_mrecs, P_CHAR aCh_output_file, 
                     P_CHAR aCh_statsfile, P_CHAR aCh_attrset, 
                     P_CHAR aCh_delim, P_CHAR aCh_fwaisfile );

VOID V_InitFieldErrorChecks( BOOL B_info, NUMBER N_mrecs, P_CHAR aCh_title,
                             P_CHAR aCh_author, P_CHAR aCh_subject,
                             P_CHAR aCh_gopher_host, NUMBER N_gopher_port,
                             P_CHAR aCh_host, P_CHAR aCh_dbname, NUMBER N_port,
                             P_CHAR aCh_operator );

VOID V_PrintQcnbcError( BOOL B_info, P_CHAR aCh_gopher_host, 
                        NUMBER N_gopher_port );



    /*
     * Structures and Typedefs
     */

struct _rterms 
{
    char    term[100];
    int     use,
            structure,
            truncation,
            position,
            relation;
} terms[200];


typedef struct 
{
    char   *name;
    char   *val;
} entry;


struct _nm{
    char name[20];
    int value;
};


struct _nm use_tab[]=
{
        {"TITLE", 4},
        {"SUBJECT", 21},
        {"abstract", 62},
        {"AUTHOR", 1}
};
int use_tab_count=4;


struct _nm rel_tab[]=
{
        {"<", 1},
        {"<=", 2},
        {"=", 3},
        {">=", 4},
        {">", 5},
        {"<>", 6}
};
int rel_tab_count=6;


struct _nm pos_tab[]=
{
        {"first in field", 1},
        {"first in subfield", 2},
        {"any position", 3}
};
int pos_tab_count=3;


struct _nm struct_tab[]=
{
        {"phrase", 1},
        {"word", 2},
        {"key", 3},
        {"year", 4},
        {"date", 5},
        {"word list", 6}
};
int struct_tab_count=6;
 




    /*
     * Variables
     */


    /* Host/Database related variables */

char    esn [10], 
        dbname [20], 
        host [100], 
        rtype [15], 
        operator [20], 
        attrset [20];
int     port,
        mrecs = 0;

    
int     maxterms = 17;      /* m contains number of fields, etc passed */
char    *dterms[200];
entry   entries [MAX_ENTRIES];
char    delim [100];
P_CHAR  aCh_title,
        aCh_author,
        aCh_subject,
        aCh_marc_file,
        aCh_gopher_host,
        aCh_binary_path;
NUMBER  N_gopher_port;
INDEX   iEnt_to_print;
BOOL    B_info = 0;


#endif /* _GO4ZGATE_H_ */
