PINITIALIZEREQUEST decodeInitRequest(DATA_DIR *d)
{
	PINITIALIZEREQUEST IR;
	DATA_DIR *sub;

	IR=NEW(INITIALIZEREQUEST);
	IR->referenceId=NULL;
	IR->protocolVersion=NULL;
	IR->options=NULL;
	IR->implementationId=NULL;
	IR->implementationName=NULL;
	IR->implementationVersion=NULL;
	IR->userInformationField=NULL;

	for(sub=d->ptr.child; sub; sub=sub->next){
		switch(sub->fldid){
			case zReferenceIdTag: {
				char *tbuf;
				tbuf=(char *)calloc(1,sub->count+1);
				COPY(tbuf,sub->ptr.data,sub->count);
				IR->referenceId=encodeOctetStr(tbuf);
				break;
			}
			case zProtocolVersionTag:{
				IR->protocolVersion=\
				encodeBitStr(sub->ptr.data,sub->count);
				break;
			}
			case zOptionsTag:{
				IR->options=encodeBitStr(sub->ptr.data,\
					sub->count);
				break;
			}
			case zPreferredMessageSizeTag:{
				long pms;
				pms=dgetnum(sub);
				IR->preferredMessageSize=pms;
				break;
			}
			case zMaximumRecordSizeTag:{
				long mrs;
				mrs=dgetnum(sub);
				IR->maximumRecordSize=mrs;
				break;
			}
			case zImplementationIdTag:{
				char *tbuf;
				tbuf=(char *)calloc(1,sub->count+1);
				COPY(tbuf,sub->ptr.data,sub->count);
				IR->implementationId=encodeOctetStr(tbuf);
				break;
			}
			case zImplementationNameTag:{
				char *tbuf;
				tbuf=(char *)calloc(1,sub->count+1);
				COPY(tbuf,sub->ptr.data,sub->count);
				IR->implementationName=encodeOctetStr(tbuf);
				break;
			}
			case zImplementationVersionTag:{
				char *tbuf;
				tbuf=(char *)calloc(1,sub->count+1);
				COPY(tbuf,sub->ptr.data,sub->count);
				IR->implementationVersion=encodeOctetStr(tbuf);
				break;
			}
		
		}
	}
        return(IR);

}
char *encodeInitializeResponse(PINITIALIZERESPONSE Init, long *len)
{
	char *outputRecord, *temp;
	DATA_DIR *d,*subdir;

	d=dmake(zInitResponseTag,ASN1_CONTEXT,zDefaultNodeCount);
        if(Init->referenceId!=NULL)
		daddchar(d,zReferenceIdTag,ASN1_CONTEXT,
			(char *)Init->referenceId->data,
			Init->referenceId->length);
	daddbits(d,zProtocolVersionTag,ASN1_CONTEXT,decodeOctetStr(Init->protocolVersion));
	daddbits(d,zOptionsTag,ASN1_CONTEXT,decodeOctetStr(Init->options));
	daddnum(d,zPreferredMessageSizeTag,ASN1_CONTEXT,
		(char *)&Init->preferredMessageSize,sizeof(Init->preferredMessageSize));
	daddnum(d,zMaximumRecordSizeTag,ASN1_CONTEXT,(char *)&Init->maximumRecordSize,
		sizeof(Init->maximumRecordSize));
	daddchar(d,zResultTag,ASN1_CONTEXT,(char *)&Init->result,sizeof(Init->result));


	if(Init->implementationId!=NULL)
		daddchar(d,zImplementationIdTag,ASN1_CONTEXT,
			(char *)Init->implementationId->data,
			Init->implementationId->length);
	if(Init->implementationName!=NULL)
		daddchar(d,zImplementationNameTag,ASN1_CONTEXT,
			(char *)Init->implementationName->data,
			Init->implementationName->length);
	if(Init->implementationVersion!=NULL)
		daddchar(d,zImplementationVersionTag,ASN1_CONTEXT,
			(char *)Init->implementationVersion->data,
			Init->implementationVersion->length);
	temp=bld_rec(d,len);
	outputRecord=(char *)calloc(1,*len);
	COPY(outputRecord,temp,*len);
	dfree(d);

	return(outputRecord);

}