
/***************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1994.

Permission to use, copy, modify, distribute, and sell this software
and its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included
in this distribution must remain intact.
2. Users of this software agree to make their best efforts (a) to
return to MCNC any improvements or extensions that they make, so that
these may be included in future releases; and (b) to inform MCNC/CNIDR
of noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

***************************************************************/
#include "platform.h"
#ifdef PLATFORM_MSDOS
#ifdef PLATFORM_BORLANDC
#include <alloc.h>
#endif
#ifdef PLATFORM_MSC
#include <malloc.h>
#endif
#endif
#include <string.h>
#include <stdio.h>
#include "netbox.h"
#include "berutil.h"
#include "ztags.h"
#include "zdefs.h"
#include "zutils.h"
#include "wais.h"
#define NEW(a) (a*)calloc(1,sizeof(a));

/* wais profile decoder *        
/* decode a returned data record that supports wais profile tags */

PWAISRECORD decodeWaisProfileRecord(DATA_DIR *d)
{


	DATA_DIR *sub;
        PWAISRECORD p=(PWAISRECORD)calloc(1,sizeof(WAISRECORD));
        
	sub=d->ptr.child;
	if(sub->fldid!=ASN1_EXTERNAL){
		/* not an external record - die*/
		return(NULL);
	}
	sub=sub->ptr.child;
	if(sub->fldid!=ASN1_SEQUENCE){
		/* missed a sequence tag */
		return(NULL);
	}
	for(; sub; sub=sub->next){
		switch(sub->fldid){
			case 0:{ /* headline */
				char *bf;

				bf=calloc(1,256);
                                strncpy(bf,sub->ptr.data,sub->count);
				p->headline=encodeOctetStr(bf);
				break;
                        }
			case 1: {   /* optional personal name */
				char *bf;

				bf=calloc(1,256);
                                strncpy(bf,sub->ptr.data,sub->count);
				p->personalName=encodeOctetStr(bf);
				break;
			}
			case 2: {   /* optional date */
				char *bf;

				bf=calloc(1,256);
                                strncpy(bf,sub->ptr.data,sub->count);
				p->date=encodeOctetStr(bf);
				break;
                        }
			case 3: /* optional score*/
				p->score=dgetnum(sub);
				break;
                        case 4:{  /* document identifer - recommend URL */
			  	char *bf;

				bf=calloc(1,256);
                                strncpy(bf,sub->ptr.data,sub->count);
				p->docId=encodeOctetStr(bf);
				break;
			}
			case 5:{
				DATA_DIR *sub3;
                                PWAISRECLIST reclist,rl;

				sub3=sub->ptr.child;
				if(sub3->fldid==ASN1_SEQUENCE){
						reclist=(PWAISRECLIST)calloc(1,sizeof(WAISRECLIST));
                                }else return(NULL);

				for(sub3=sub3->ptr.child; sub3; sub3=sub3->next){
					switch(sub3->fldid){
						case ASN1_SEQUENCE:
							reclist->next=(PWAISRECLIST)calloc(1,sizeof(WAISRECLIST));
							reclist=reclist->next;
                                                        break;
						case 5: /* data */
						{
							char *bf;
                                                        bf=calloc(1,sub3->count+1);
                                                	COPY(bf,sub3->ptr.data,sub3->count);
							reclist->item=encodeOctetStr(bf);
							break;
                                                }
						default:
							return(NULL);
					}
				}
                                p->reclist=rl;
			}                        
                }
	}
	return(p);
}
