/***************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1994.

Permission to use, copy, modify, distribute, and sell this software
and its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included
in this distribution must remain intact.
2. Users of this software agree to make their best efforts (a) to
return to MCNC any improvements or extensions that they make, so that
these may be included in future releases; and (b) to inform MCNC/CNIDR
of noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

***************************************************************/
#ifndef _z3950_
#define _z3950_

/* Error codes */
#define ZBASE 5000
#define ZINITIALIZED ZBASE+1
#define ZNOTINITIALIZED ZBASE+2
#define ZNOMORECONNECTIONS ZBASE+3
#define ZDECODEFAILED ZBASE+4
#define ZCANTOPENFILE ZBASE+5
#define ZNOTCONNECTED ZBASE+6
#define ZGETPEFAILED ZBASE+7
#define ZUNDOCUMENTED ZBASE+8
/* This will be defined by Nassib's error codes for netbox */
#define ZTIMEOUT ZBASE+9


/* Function return codes */
#define ZINITRESPONSE ZBASE+50
#define ZSEARCHRESPONSE ZBASE+51
#define ZPRESENTRESPONSE ZBASE+52
#define ZACCESSREQUEST ZBASE+53
#define ZUNSUPPORTEDPDU ZBASE+54
#define ZDIAGRETURNED ZBASE+55

/* Attribute sets supported */
#define BIB1_ATTR_SET 0
#define STAS_ATTR_SET 1

/* Record Syntaxes supported */
#define USMARC_RECORD_SYNTAX 0
#define SUTRS_RECORD_SYNTAX 1

/* Functions served by the DLL */
int FAR PASCAL zStartLogging(char *pFile,char *pFlag);
void FAR PASCAL zStopLogging();
int FAR PASCAL zStartup();
int FAR PASCAL zGetLastError();
void FAR PASCAL zCleanup();
int FAR PASCAL zCloseConnection();
int FAR PASCAL zOpenConnection(char *pHost, int pPort);
int FAR PASCAL zInitRequest(char *pReferenceId, char *pIdAuthentication,
		long pPreferredMsgSize, long pMaxRecordSize,
		char *pUserInfoField);
int FAR PASCAL zSearchRequest(char *pReferenceId, char *resultSetName,
		int pReplaceIndicator, char *databaseNames,
		int attributeSetId, char *query);
int FAR PASCAL zPresentRequest(char *pReferenceId, char *pResultSetId,
		long pResultSetStartPoint, long pNumRecsRequested,
		char *pElementSetNames,	int pPreferredRecordSyntax);
int FAR PASCAL zGetPDU(long pTimeOut);
long FAR PASCAL zGetSearchResults();
long FAR PASCAL zGetPresentResults();
long FAR PASCAL zGetRecord(long pRecNum, long pStartPoint,
		char *pBuf, long pMaxBufSize);
long FAR PASCAL zGetBuffer(char *pBuffer, long pMaxLen) ;

#endif /* _z3950_ */