/***************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1994.

Permission to use, copy, modify, distribute, and sell this software
and its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included
in this distribution must remain intact.
2. Users of this software agree to make their best efforts (a) to
return to MCNC any improvements or extensions that they make, so that
these may be included in future releases; and (b) to inform MCNC/CNIDR
of noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

***************************************************************/
#ifndef _ztags_
#define _ztags_

/* 
In presentation elements, if PEform is 0, then the element is not
constructed and its child is the data.  If it is 1, it is a constructed
element and its child is a PEList.
*/
#define ZNOTCONSTRUCTED 0
#define ZCONSTRUCTED 1
#define zInitRequestTag 20
#define zInitResponseTag 21
#define zSearchRequestTag 22
#define zSearchResponseTag 23
#define zPresentRequestTag 24
#define zPresentResponseTag 25
#define zDeleteResultSetRequestTag 26
#define zDeleteResultSetResponseTag 27
#define zAccessControlRequestTag 28
#define zAccessControlResponseTag 29
#define zScanRequestTag 35
#define zScanResponseTag 36
#define zReferenceIdTag 2
#define zProtocolVersionTag 3
#define zOptionsTag 4
#define zPreferredMessageSizeTag 5
#define zMaximumRecordSizeTag 6
#define zIdAuthenticationTag 7
#define zImplementationNameTag 111
#define zImplementationIdTag 110
#define zImplementationVersionTag 112
#define zUserInfoFieldTag 11
#define zResultSetIdTag 31
#define zResultSetStartPointTag 30
#define zNumberOfRecordsRequestedTag 29
#define zElementSetNamesTag 19
#define zPreferredRecordSyntaxTag 104
#define zResultTag 12
#define zReferenceIdTag 2
#define zSmallSetUpperBoundTag 13
#define zLargeSetLowerBoundTag 14
#define zMediumSetPresentNumberTag 15
#define zReplaceIndicatorTag 16
#define zResultSetNameTag 17
#define zDatabaseNamesTag 18
#define zDatabaseNameTag 105
#define zSmallSetElementSetNames 100
#define zMediumSetElementSetNames 101
#define zQueryTag 21
#define zType0QueryTag 0
#define zType1QueryTag 1
#define zType2QueryTag 2
#define zType100QueryTag 100 
#define zType101QueryTag 101 
#define zOperandTag 0 
#define zAttributesPlusTermTag 102
#define zAttributeListTag 44 
#define zQueryTermTag 45 
#define zAttributeTypeTag 120
#define zAttributeValueTag 121
#define zNumberOfRecordsReturnedTag 24
#define zNextResultSetPositionTag 25
#define zPresentStatusTag 27
#define zDatabaseOrSurDiagnosticsTag 28
#define zNonSurrogateDiagnosticTag 130
#define zGenericTag 0
#define zDatabaseSpecificTag 1
#define zElementSetNameTag 103
#define zBooleanQueryTag 1
#define zOperatorTag 46
#define zAndTag 0
#define zOrTag 1
#define zAndNotTag 2
#define zSmallSetElementSetNamesTag 100
#define zMediumSetElementSetNamesTag 101
#define zOIDTag 6
#define zProtocolErrorTag -1
#define zProtocolOk 1
#define zDefaultNodeCount 15
#define zResultCountTag 23
#define zSearchStatusTag 22
#define zResultSetStatusTag 26
#define zIntegerTag 2
#define zVisibleStringTag 26
#define zDeleteOperationStatusTag 0
#define zDeleteListStatusesTag 1
#define zNumberNotDeletedTag 34
#define zBulkStatusesTag 35
#define zDeleteMessageTag 36
#define zDeleteSetStatusTag 33
#define zDeleteOperationTag 32
#define zDeleteOperationListTag 0
#define zDeleteOperationAllTag 1

#endif /* _ztags_ */
