/***************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1994.

Permission to use, copy, modify, distribute, and sell this software
and its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included
in this distribution must remain intact.
2. Users of this software agree to make their best efforts (a) to
return to MCNC any improvements or extensions that they make, so that
these may be included in future releases; and (b) to inform MCNC/CNIDR
of noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

***************************************************************/
#ifndef _ztypes_
#define _ztypes_

/*typedefs */
typedef struct _presentationElement PRESENTATIONELEMENT;
typedef struct _presentationElement *PPRESENTATIONELEMENT;
typedef struct _presentationElement FAR *LPPRESENTATIONELEMENT;

typedef struct _presentationElementList PRESENTATIONELEMENTLIST;
typedef struct _presentationElementList *PPRESENTATIONELEMENTLIST;
typedef struct _presentationElementList FAR *LPPRESENTATIONELEMENTLIST;

typedef struct _presentationElement ANY;
typedef struct _presentationElement *PANY;
typedef struct _presentationElement FAR *LPANY;

typedef struct _presentationElement EXTERNAL;
typedef struct _presentationElement *PEXTERNAL;
typedef struct _presentationElement FAR *LPEXTERNAL;

typedef struct _octetString OCTETSTRING;
typedef struct _octetString *POCTETSTRING;
typedef struct _octetString FAR *LPOCTETSTRING;

typedef struct _octetString BITSTRING;
typedef struct _octetString *PBITSTRING;
typedef struct _octetString FAR *LPBITSTRING;

typedef struct _octetString OBJECTIDENTIFIER;
typedef struct _octetString *POBJECTIDENTIFIER;
typedef struct _octetString FAR *LPOBJECTIDENTIFIER;

typedef struct _initializeRequest INITIALIZEREQUEST;
typedef struct _initializeRequest *PINITIALIZEREQUEST;
typedef struct _initializeRequest FAR *LPINITIALIZEREQUEST;

typedef struct _initializeResponse INITIALIZERESPONSE;
typedef struct _initializeResponse *PINITIALIZERESPONSE;
typedef struct _initializeResponse FAR *LPINITIALIZERESPONSE;

typedef struct _searchRequest SEARCHREQUEST;
typedef struct _searchRequest *PSEARCHREQUEST;
typedef struct _searchRequest FAR *LPSEARCHREQUEST;

typedef struct _searchResponse SEARCHRESPONSE;
typedef struct _searchResponse *PSEARCHRESPONSE;
typedef struct _searchResponse FAR *LPSEARCHRESPONSE;

typedef struct _presentRequest PRESENTREQUEST;
typedef struct _presentRequest *PPRESENTREQUEST;
typedef struct _presentRequest FAR *LPPRESENTREQUEST;

typedef struct _presentResponse PRESENTRESPONSE;
typedef struct _presentResponse *PPRESENTRESPONSE;
typedef struct _presentResponse FAR *LPPRESENTRESPONSE;

typedef struct _accessControlRequest ACCESSCONTROLREQUEST;
typedef struct _accessControlRequest *PACCESSCONTROLREQUEST;
typedef struct _accessControlRequest FAR *LACCESSCONTROLREQUEST;

typedef struct _accessControlResponse  ACCESSCONTROLRESPONSE;
typedef struct _accessControlResponse  *PACCESSCONTROLRESPONSE;
typedef struct _accessControlResponse FAR *LACCESSCONTROLRESPONSE;

typedef struct _deleteResultSetRequest DELETERESULTSETREQUEST;
typedef struct _deleteResultSetRequest *PDELETERESULTSETREQUEST;
typedef struct _deleteResultSetRequest FAR *LPDELETERESULTSETREQUEST;

typedef struct _deleteResultSetResponse DELETERESULTSETRESPONSE;
typedef struct _deleteResultSetResponse *PDELETERESULTSETRESPONSE;
typedef struct _deleteResultSetResponse FAR *LPDELETERESULTSETRESPONSE;

typedef struct _resultSetList RESULTSETLIST;
typedef struct _resultSetList *PRESULTSETLIST;
typedef struct _resultSetList FAR *LPRESULTSETLIST;

typedef struct _listStatuses LISTSTATUSES;
typedef struct _listStatuses *PLISTSTATUSES;
typedef struct _listStatuses FAR *LPLISTSTATUSES;

typedef struct _records RECORDS;
typedef struct _records *PRECORDS;
typedef struct _records FAR *LPRECORDS;

typedef struct _namePlusRecord NAMEPLUSRECORD;
typedef struct _namePlusRecord *PNAMEPLUSRECORD;
typedef struct _namePlusRecord FAR *LPNAMEPLUSRECORD;

typedef struct _namePlusRecordList NAMEPLUSRECORDLIST;
typedef struct _namePlusRecordList *PNAMEPLUSRECORDLIST;
typedef struct _namePlusRecordList FAR *LPNAMEPLUSRECORDLIST;

typedef struct _dbRecordOrSurrogate DBRECORDORSURROGATE;
typedef struct _dbRecordOrSurrogate *PDBRECORDORSURROGATE;
typedef struct _dbRecordOrSurrogate FAR *LPDBRECORDORSURROGATE;

typedef struct _diagRecord DIAGRECORD;
typedef struct _diagRecord *PDIAGRECORD;
typedef struct _diagRecord FAR *LPDIAGRECORD;

typedef struct _elementSetNames ELEMENTSETNAMES;
typedef struct _elementSetNames *PELEMENTSETNAMES;
typedef struct _elementSetNames FAR *LPELEMENTSETNAMES;

typedef struct _elementSetPlusDB ELEMENTSETPLUSDB;
typedef struct _elementSetPlusDB *PELEMENTSETPLUSDB;
typedef struct _elementSetPlusDB FAR *LPELEMENTSETPLUSDB;

typedef struct _pdu PDU;
typedef struct _pdu *PPDU;
typedef struct _pdu FAR *LPPDU;

typedef struct _attributesPlusTerm ATTRIBUTESPLUSTERM;
typedef struct _attributesPlusTerm *PATTRIBUTESPLUSTERM;
typedef struct _attributesPlusTerm FAR *LPATTRIBUTESPLUSTERM;

typedef struct _attributeElement ATTRIBUTEELEMENT;
typedef struct _attributeElement *PATTRIBUTEELEMENT;
typedef struct _attributeElement FAR *LPATTRIBUTEELEMENT;

typedef struct _attributeElementList ATTRIBUTEELEMENTLIST;
typedef struct _attributeElementList *PATTRIBUTEELEMENTLIST;
typedef struct _attributeElementList FAR *LPATTRIBUTEELEMENTLIST;

typedef struct _rPNQuery RPNQUERY;
typedef struct _rPNQuery *PRPNQUERY;
typedef struct _rPNQuery FAR *LPRPNQUERY;

typedef struct _rPNStructure RPNSTRUCTURE;
typedef struct _rPNStructure *PRPNSTRUCTURE;
typedef struct _rPNStructure FAR *LPRPNSTRUCTURE;

typedef struct _query QUERY;
typedef struct _query *PQUERY;
typedef struct _query FAR *LPQUERY;

typedef struct _operator OPERATOR;
typedef struct _operator *POPERATOR;
typedef struct _operator FAR *LPOPERATOR;

typedef struct _operand OPERAND;
typedef struct _operand *POPERAND;
typedef struct _operand FAR *LPOPERAND;

typedef struct _databaseNameList DATABASENAMELIST;
typedef struct _databaseNameList *PDATABASENAMELIST;
typedef struct _databaseNameList FAR *LPDATABASENAMELIST;

typedef struct _waisrec WAISRECORD;
typedef struct _waisrec *PWAISRECORD;
typedef struct _waisrec FAR *LWAISRECORD;

typedef struct _waisreclist WAISRECLIST;
typedef struct _waisreclist *PWAISRECLIST;
typedef struct _waisreclist FAR *LWAISRECLIST;



#endif /* _ztypes_ */

