#ifndef _fwais_
#define _fwais_

/* Error Messages */
#define FWNOSENDPRESENTREQ "Couldn't send present request to the server"
#define FWNOGETPRESENTRES "Connection closed or timeout during present response"
#define FWNOSENDINITREQ "Couldn't send init request to the server"
#define FWNOSENDSEARCHREQ "Couldn't send search request to the server"
#define FWNOGETRES "Connection closed or timeout waiting for response"
#define FWNOQUERYTERM "You must supply a valid query term(s)"
#define FWNOCONNECT "Couldn't open a TCP connection"
#define FWINITDENIED "Initialization to this server was DENIED"
#define FWNOHITS "The query produced no results"

/* Misc stuff */
#define PROFILEFN "fwais.ini"
#define PROFILEGROUP "Default"
#define TEMPGROUP "Temp"
#define MAXSESSIONSTRING 1024
#define MAXNETBUFFERSIZE 50000
#define MAXNUMRECS 500

/* "Local" session stuff (not specifically related to Z39.50) */
typedef struct _sessionStuff SESSIONSTUFF;
typedef struct _sessionStuff *PSESSIONSTUFF;
struct _sessionStuff {
        long numHits;
        long numRecords;
        FILE *logFp;
        OCTETSTRING *records[MAXNUMRECS];
	CHAR Diag[MAXSESSIONSTRING];
};

/* The big, huge, enormous Session table */
struct _session {
	CHAR Host[MAXSESSIONSTRING];
        int Port;
        long TimeOut;
	CHAR OutputFile[MAXSESSIONSTRING];
	CHAR StatsFile[MAXSESSIONSTRING];
	CHAR LogFile[MAXSESSIONSTRING];
	CHAR iAuthentication[MAXSESSIONSTRING];
	CHAR iImpID[MAXSESSIONSTRING];
	CHAR iImpName[MAXSESSIONSTRING];
	CHAR iImpVersion[MAXSESSIONSTRING];
	CHAR iProtocolVersion[MAXSESSIONSTRING];
	CHAR iOptions[MAXSESSIONSTRING];
        long iPreferredMsgSize;
        long iMaxRecSize;
	CHAR iUserInformationField[MAXSESSIONSTRING];
	CHAR iReferenceId[MAXSESSIONSTRING];
	CHAR sReferenceId[MAXSESSIONSTRING];
        long sSmallSetUpperBound;
        long sLargeSetLowerBound;
        long sMedSetPresentNum;
	unsigned char sReplaceIndicator;
	CHAR sResultSetName[MAXSESSIONSTRING];
	CHAR sDBNames[MAXSESSIONSTRING];
	CHAR sSmallSetElementSetNames[MAXSESSIONSTRING];
	CHAR sMediumSetElementSetNames[MAXSESSIONSTRING];
	CHAR sPreferredRecordSyntax[MAXSESSIONSTRING];
	CHAR sQuery[MAXSESSIONSTRING];
	CHAR sAttributeSet[MAXSESSIONSTRING];
	CHAR pReferenceId[MAXSESSIONSTRING];
	CHAR pResultSetId[MAXSESSIONSTRING];
        long pResultSetStartPoint;
        long pNumRecsReq;
	CHAR pElementSetNames[MAXSESSIONSTRING];
	CHAR pPreferredRecSyntax[MAXSESSIONSTRING];
};
 
typedef struct _session SESSION;
typedef struct _session *PSESSION;

#endif /* _fwais_ */

